summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorIan Stakenvicius <axs@gentoo.org>2016-06-03 12:12:57 -0400
committerIan Stakenvicius <axs@gentoo.org>2016-06-07 22:11:50 -0400
commitd016c84152e02f19059e8d1f243f052587d2e3aa (patch)
tree0e8a26e6d2255cdb6ea84ac19da88c8c3ba7487b /sys-cluster/torque
parentapp-editors/qxmledit: add missing dep; use EPREFIX where appropriate (diff)
downloadgentoo-d016c84152e02f19059e8d1f243f052587d2e3aa.tar.gz
gentoo-d016c84152e02f19059e8d1f243f052587d2e3aa.tar.bz2
gentoo-d016c84152e02f19059e8d1f243f052587d2e3aa.zip
sys-cluster/torque: introduce v6.0.1 with cgroups support
So far there has been very little testing done with this version, and the in-ebuild cgroups support needs to be expanded (checks against kernel settings added, etc). Package-Manager: portage-2.2.28
Diffstat (limited to 'sys-cluster/torque')
-rw-r--r--sys-cluster/torque/Manifest1
-rw-r--r--sys-cluster/torque/metadata.xml1
-rw-r--r--sys-cluster/torque/torque-6.0.1.ebuild176
3 files changed, 178 insertions, 0 deletions
diff --git a/sys-cluster/torque/Manifest b/sys-cluster/torque/Manifest
index 2b20c8acc5c..7b157794bdf 100644
--- a/sys-cluster/torque/Manifest
+++ b/sys-cluster/torque/Manifest
@@ -1,3 +1,4 @@
DIST torque-2.5.13.tar.gz 5854910 SHA256 ab59d4c8e8b45383ddd8202fa83956816175e348bb955a4ad5f7e3cd4dde5ff9 SHA512 e08ddf3950bb32177f4bc504a502fae3928a616739c28ca9687c5207606817d4589583306508a2c568cf19fc8c5617dc4a9decc81576c2875660b715c256cfcf WHIRLPOOL 29eefb89d1eb9d6a81735aa117922a1eb0b72e14eeccab7dbd70cdcf01431b7ecd9c3927e1c5c28b7f42d6739b28f45386740b92adb790ccdf9803e4c6e38534
DIST torque-4.1.7.tar.gz 6218108 SHA256 3c86b2d84589f54ac222e81dd1953d153e1d836163d2000412369fefd25fb2af SHA512 5a085c0a7b205fed075bff4599db90ca5c4bb5f22d87d76fd56539d5cc1935bb8eeffcd4d18ba84401bd4ca128718070b69c8b91ab6814a4638622ba351654e6 WHIRLPOOL cae9216f0cebc22927eec2d1f007b1a3c4a6cc619f2926c40a5f46e0bd0eec19691f9aafcad4fe727e2c5ed2485d11c972603cca613269f82147ff1dc41f1ba4
DIST torque-4.2.9.tar.gz 6294022 SHA256 46f1f319683af6d3820e18cda69ce59113c9a5c192e1f07826007be69385889b SHA512 898703fa1d02310c22e2a02b86d67ca52ebed46684597931944edebb39f8293746739c8dca9cd10e07c2e7274c3dd7f65a5664d1980817e3feec58952c4cf4d1 WHIRLPOOL e65be66b056a519ebd1c30c2c1ae2ddf43bc4e617a52d3caced1e6dfd2b0d8b2a83c26a0f2e6e41cfae791aca68b6f91424745b2baffa2085fccc8f6ae9b8e04
+DIST torque-6.0.1.tar.gz 41229268 SHA256 39623e364a87976a8d657fa47965703ca7ae7c32110ff18eccc6282dc609f3de SHA512 63251ec163feb8d6be788db79de497b2bb1cb98b0d62e2c43fa50d1a4b25b0f8075072c22c3aa4535d6a83a6be987c6cddda47829778bbef3b5006bba936ed87 WHIRLPOOL 98aaf09965416a8e227ef3cdae59f690e4581a2ecde6c5c6e5aa5e99f08ac14012ffb8611b29624f6302098495b94f8e79084fa8478160d71c07f8343ec81839
diff --git a/sys-cluster/torque/metadata.xml b/sys-cluster/torque/metadata.xml
index b47af35a601..b1e48d8659e 100644
--- a/sys-cluster/torque/metadata.xml
+++ b/sys-cluster/torque/metadata.xml
@@ -10,6 +10,7 @@
<name>Ian Stakenvicius</name>
</maintainer>
<use>
+ <flag name="cgroups">Enable pbs_mom to use linux cgroups to isolate jobs</flag>
<flag name="cpusets">Enable pbs_mom to utilize linux cpusets if available</flag>
<flag name="drmaa">Enable the Distributed Resource Management Application API</flag>
<flag name="munge">Enable authentication via munge</flag>
diff --git a/sys-cluster/torque/torque-6.0.1.ebuild b/sys-cluster/torque/torque-6.0.1.ebuild
new file mode 100644
index 00000000000..caed69c5d93
--- /dev/null
+++ b/sys-cluster/torque/torque-6.0.1.ebuild
@@ -0,0 +1,176 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+inherit flag-o-matic eutils linux-info
+
+DESCRIPTION="Resource manager and queuing system based on OpenPBS"
+HOMEPAGE="http://www.adaptivecomputing.com/products/open-source/torque"
+# TODO: hopefully moving to github tags soon
+# http://www.supercluster.org/pipermail/torquedev/2013-May/004519.html
+SRC_URI="http://www.adaptivecomputing.com/index.php?wpfb_dl=3032 -> ${P}.tar.gz"
+
+LICENSE="torque-2.5"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sparc ~x86"
+IUSE="cgroups cpusets +crypt doc drmaa kernel_linux libressl munge nvidia server +syslog tk"
+
+DEPEND_COMMON="
+ sys-libs/zlib
+ sys-libs/readline:0=
+ dev-libs/libxml2
+ !libressl? ( dev-libs/openssl:0= )
+ libressl? ( dev-libs/libressl:0= )
+ cpusets? ( sys-apps/hwloc )
+ munge? ( sys-auth/munge )
+ nvidia? ( >=x11-drivers/nvidia-drivers-275 )
+ tk? (
+ dev-lang/tk:0=
+ dev-lang/tcl:0=
+ )
+ syslog? ( virtual/logger )
+ !!games-util/qstat"
+
+# libncurses.so is only needed for configure check on readline
+DEPEND="${DEPEND_COMMON}
+ sys-libs/ncurses:*
+ !!sys-cluster/slurm"
+
+RDEPEND="${DEPEND_COMMON}
+ crypt? ( net-misc/openssh )
+ !crypt? ( net-misc/netkit-rsh )
+ !dev-libs/uthash"
+
+# Torque should depend on dev-libs/uthash but that's pretty much impossible
+# to patch in as they ship with a broken configure such that files referenced
+# by the configure.ac and Makefile.am are missing.
+# http://www.supercluster.org/pipermail/torquedev/2014-October/004773.html
+
+S="${WORKDIR}"/${P}-1456945733_daea91b
+
+pkg_setup() {
+ PBS_SERVER_HOME="${PBS_SERVER_HOME:-/var/spool/${PN}}"
+
+ # Find a Torque server to use. Check environment, then
+ # current setup (if any), and fall back on current hostname.
+ if [ -z "${PBS_SERVER_NAME}" ]; then
+ if [ -f "${ROOT}${PBS_SERVER_HOME}/server_name" ]; then
+ PBS_SERVER_NAME="$(<${ROOT}${PBS_SERVER_HOME}/server_name)"
+ else
+ PBS_SERVER_NAME=$(hostname -f)
+ fi
+ fi
+
+ if use cpusets || use cgroups; then
+ if ! use kernel_linux; then
+ einfo
+ elog " Torque currently only has support for cpusets and cgroups in linux."
+ elog "Assuming you didn't really want this USE flag and ignoring its state."
+ einfo
+ else
+ linux-info_pkg_setup
+ if ! linux_config_exists || ! linux_chkconfig_present CPUSETS; then
+ einfo
+ elog " Torque support for cpusets will require that you recompile"
+ elog "your kernel with CONFIG_CPUSETS enabled."
+ einfo
+ fi
+ fi
+ fi
+}
+
+src_prepare() {
+ # We install to a valid location, no need to muck with ld.so.conf
+ # --without-loadlibfile is supposed to do this for us...
+ sed -i '/mk_default_ld_lib_file || return 1/d' buildutils/pbs_mkdirs.in || die
+}
+
+src_configure() {
+ econf \
+ $(use_enable tk gui) \
+ $(use_enable tk tcl-qstat) \
+ $(use_enable syslog) \
+ $(use_enable server) \
+ $(use_enable drmaa) \
+ $(use_enable munge munge-auth) \
+ $(use_enable nvidia nvidia-gpus) \
+ $(usex crypt --with-rcp --with-rcp scp mom_rcp) \
+ $(usex kernel_linux $(use_enable cpusets cpuset) --disable-cpuset) \
+ $(usex kernel_linux $(use_enable cgroups) --disable-cgroups) \
+ --with-server-home=${PBS_SERVER_HOME} \
+ --with-environ=/etc/pbs_environment \
+ --with-default-server=${PBS_SERVER_NAME} \
+ --disable-gcc-warnings \
+ --disable-silent-rules \
+ --with-tcp-retry-limit=2 \
+ --without-loadlibfile
+}
+
+src_install() {
+ local dir
+
+ DOCS=( CHANGELOG README.* Release_Notes )
+ use doc && DOCS+=( doc/admin_guide.ps doc/*.pdf )
+
+ default
+
+ # The build script isn't alternative install location friendly,
+ # So we have to fix some hard-coded paths in tclIndex for xpbs* to work
+ for file in $(find "${ED}" -iname tclIndex); do
+ sed \
+ -e "s/${ED//\// }/ /" \
+ -i "${file}" || die
+ done
+
+ for dir in $(find "${ED}/${PBS_SERVER_HOME}" -type d); do
+ keepdir "${dir#${ED}}"
+ done
+
+ if use server; then
+ newinitd "${FILESDIR}"/pbs_server-init.d-munge pbs_server
+ newinitd "${FILESDIR}"/pbs_sched-init.d pbs_sched
+ fi
+ newinitd "${FILESDIR}"/pbs_mom-init.d-munge pbs_mom
+ newconfd "${FILESDIR}"/${PN}-conf.d-munge ${PN}
+ newinitd "${FILESDIR}"/trqauthd-init.d trqauthd
+ newenvd "${FILESDIR}"/${PN}-env.d 25${PN}
+}
+
+pkg_preinst() {
+ if [[ -f "${ROOT}etc/pbs_environment" ]]; then
+ cp "${ROOT}etc/pbs_environment" "${ED}"/etc/pbs_environment || die
+ fi
+
+ if use server && [[ -f "${ROOT}${PBS_SERVER_HOME}/server_priv/nodes" ]]; then
+ cp \
+ "${EROOT}${PBS_SERVER_HOME}/server_priv/nodes" \
+ "${ED}/${PBS_SERVER_HOME}/server_priv/nodes" || die
+ fi
+
+ echo "${PBS_SERVER_NAME}" > "${ED}${PBS_SERVER_HOME}/server_name" || die
+
+ # Fix up the env.d file to use our set server home.
+ sed \
+ -e "s:/var/spool/${PN}:${PBS_SERVER_HOME}:g" \
+ -i "${ED}"/etc/env.d/25${PN} || die
+
+ if use munge; then
+ sed -i 's,\(PBS_USE_MUNGE=\).*,\11,' "${ED}"/etc/conf.d/${PN} || die
+ fi
+}
+
+pkg_postinst() {
+ elog " If this is the first time torque has been installed, then you are not"
+ elog "ready to start the server. Please refer to the documentation located at:"
+ elog "http://docs.adaptivecomputing.com/torque/${PN//./-}/Content/topics/1-installConfig/initializeConfigOnServer.htm"
+ if [[ -z "${REPLACING_VERSIONS}" ]] || [[ ${REPLACING_VERSIONS} < 4 ]]; then
+ echo
+ elog "Important 4.0+ updates"
+ elog " - The on-wire protocol version has been changed."
+ elog " Versions of Torque before 4.0.0 are no longer able to communicate."
+ elog " - pbs_iff has been replaced by trqauthd, you will now need to add"
+ elog " trqauthd to your default runlevel."
+ fi
+}